//+------------------------------------------------------------------+
//|                                  Dolly_Trading Times #3_auto.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property link      " Code used from  i-ParamonWorkTime.mq4 " 

#property indicator_chart_window

extern int    TradingTimes_NumberOfDays = 1; 

//Tokyo
//Time Zone
//+9
//Opening Time:
//9:00
//Closing Time:
//18:00
//Early Closing Time:
//12:30



//EUROPE
//Opening Time:
//7:00
//Closing Time:
//16:00
//Early Closing Time:
//13:00
extern string EUROPE_Open        = "07:00";
extern color  EUROPE_Color       = Purple; 
extern color  EUROPE_TEXT_Color  = Violet;
extern bool   Show_EUROPE_Open   = true;
extern string EUROPE1_Close      = "16:00";
extern color  EUROPE1_Color      = Maroon;
extern color  EUROPE1_TEXT_Color = Crimson;
extern bool   Show_EUROPE1_Close = true;

//UK
//Opening Time:
//8:00
//Closing Time:
//17:00
//Early Closing Time:
//13:00
extern string LONDON_Open      = "08:00";  
extern color  LONDON_Color      = MidnightBlue;
extern color  LONDON_TEXT_Color = DodgerBlue;
extern bool Show_LONDON_Open  = true;

//US
//Opening Time:
//8:00
//Closing Time:
//17:00
//Early Closing Time:
//15:00
extern string US_Open       = "08:00";
extern color  US_Color      = Indigo;
extern color  US_TEXT_Color = MediumPurple;
extern bool Show_US_Open = true;

extern bool Show_Daily_Trade_TEXT = true;

string Broker;
string _EUROPE_Open;        
string _EUROPE1_Close; 
string _LONDON_Open;     
string _US_Open;       

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
void init() {
  
  Broker=TerminalCompany();
  
  DeleteObjects();
  
  for (int i=0; i<TradingTimes_NumberOfDays; i++) {
    CreateObjects("DollyTIME1"+i, EUROPE_Color);
    CreateObjects("DollyTIME2"+i, LONDON_Color);
    CreateObjects("DollyTIME3"+i, US_Color);
    CreateObjects("DollyTIME4"+i, EUROPE1_Color);   
    
  }
  
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
void deinit() {
  DeleteObjects();
  ObjectDelete("TT1");ObjectDelete("TT2");ObjectDelete("TT3");
  ObjectDelete("TT4");ObjectDelete("TT5");ObjectDelete("TT6");
  ObjectDelete("TT7");ObjectDelete("TT8");
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateObjects(string TRADETIMES, color cl) {
  ObjectCreate(TRADETIMES, OBJ_TREND, 0, 0,0, 0,0);
  ObjectSet(TRADETIMES, OBJPROP_STYLE, STYLE_SOLID);
  ObjectSet(TRADETIMES, OBJPROP_WIDTH,3);
  ObjectSet(TRADETIMES, OBJPROP_COLOR, cl);
  ObjectSet(TRADETIMES, OBJPROP_BACK, True);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteObjects() {
  for (int i=0; i<TradingTimes_NumberOfDays; i++) {
    ObjectDelete("DollyTIME1"+i);
    ObjectDelete("DollyTIME2"+i);
    ObjectDelete("DollyTIME3"+i);
    ObjectDelete("DollyTIME4"+i);   
  }
}

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
void start()
 {  
 
  datetime dt=CurTime();
    
  //Comment("EU open: 2006.11.11 07:00","  GMT:",REGION_TO_GMT("EUROPE","2006.11.11 07:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("EUROPE","2006.11.11 07:00")));
  //Comment("EU close: 2006.11.11 16:00","  GMT:",REGION_TO_GMT("EUROPE","2006.11.11 16:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("EUROPE","2006.11.11 16:00")));
  //Comment("UK open: 2006.11.11 08:00","  GMT:",REGION_TO_GMT("UK","2006.11.11 08:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("UK","2006.11.11 08:00")));
  //Comment("UK close: 2006.11.11 17:00","  GMT:",REGION_TO_GMT("UK","2006.11.11 17:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("UK","2006.11.11 17:00")));
  //Comment("US open: 2006.11.11 08:00","  GMT:",REGION_TO_GMT("US","2006.11.11 08:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("US","2006.11.11 08:00")));  
  //Comment("US close: 2006.11.11 17:00","  GMT:",REGION_TO_GMT("US","2006.11.11 17:00"),"  ",Broker,":",GMT_TO_REGION(Broker,REGION_TO_GMT("US","2006.11.11 17:00")));  


  for (int i=0; i<TradingTimes_NumberOfDays; i++) {
  if (Show_EUROPE_Open==true)
  {

   _EUROPE_Open        = GMT_TO_REGION(Broker,REGION_TO_GMT("EUROPE",TimeToStr(iTime(Symbol(),PERIOD_D1,i),TIME_DATE)+" "+EUROPE_Open));
   _EUROPE1_Close      = GMT_TO_REGION(Broker,REGION_TO_GMT("EUROPE",TimeToStr(iTime(Symbol(),PERIOD_D1,i),TIME_DATE)+" "+EUROPE1_Close));
   _LONDON_Open        = GMT_TO_REGION(Broker,REGION_TO_GMT("UK",TimeToStr(iTime(Symbol(),PERIOD_D1,i),TIME_DATE)+" "+LONDON_Open));
   _US_Open            = GMT_TO_REGION(Broker,REGION_TO_GMT("US",TimeToStr(iTime(Symbol(),PERIOD_D1,i),TIME_DATE)+" "+US_Open));
  
    DrawObjects(dt, "DollyTIME1"+i, _EUROPE_Open, _EUROPE_Open);}
   if (Show_LONDON_Open==true)
   {
    DrawObjects(dt, "DollyTIME2"+i, _LONDON_Open, _LONDON_Open);}
   if (Show_US_Open==true)
   { 
    DrawObjects(dt, "DollyTIME3"+i, _US_Open, _US_Open);}
   if (Show_EUROPE1_Close==true)
   { 
    DrawObjects(dt, "DollyTIME4"+i, _EUROPE1_Close, _EUROPE1_Close);}
    
    dt=decDateTradeDay(dt);
    while (TimeDayOfWeek(dt)>5) dt=decDateTradeDay(dt);
  }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DrawObjects(datetime dt, string TRADETIMES, string tb, string te) {
  datetime t1, t2;
  double   p1, p2;
  int      b1, b2;

  t1=StrToTime(TimeToStr(dt, TIME_DATE)+" "+tb);
  t2=StrToTime(TimeToStr(dt, TIME_DATE)+" "+te);
  b1=iBarShift(NULL, 0, t1);
  b2=iBarShift(NULL, 0, t2);
  p1=High[Highest(NULL, 0, MODE_HIGH, b1-b2, b2)];
  p2=Low [Lowest (NULL, 0, MODE_LOW , b1-b2, b2)];
  
  ObjectSet(TRADETIMES, OBJPROP_TIME1 , t1);
  ObjectSet(TRADETIMES, OBJPROP_PRICE1, p1);
  ObjectSet(TRADETIMES, OBJPROP_TIME2 , t2);
  ObjectSet(TRADETIMES, OBJPROP_PRICE2, p2);

 if (Show_Daily_Trade_TEXT==true)
 {
   ObjectDelete("TT1");
   TT1( "TT1", 460, 12,4);
   ObjectSetText( "TT1","EUROPE Open" , 9, "Arial", EUROPE_TEXT_Color);
    
   ObjectDelete("TT2");
   TT2( "TT2", 460, 12,4);
   ObjectSetText( "TT2",""+EUROPE_Open+"" , 9, "Arial", Silver);
   
   
   ObjectDelete("TT3");
   TT3( "TT3", 475, 12,4);
   ObjectSetText( "TT3","LONDON Open" , 9, "Arial", LONDON_TEXT_Color);
    
   ObjectDelete("TT4");
   TT4( "TT4", 475, 12,4);
   ObjectSetText( "TT4",""+LONDON_Open+"" , 9, "Arial", Silver);
   
   
   ObjectDelete("TT5");
   TT5( "TT5", 490, 12,4);
   ObjectSetText( "TT5","US Open" , 9, "Arial", US_TEXT_Color);
    
   ObjectDelete("TT6");
   TT6( "TT6", 490, 12,4);
   ObjectSetText( "TT6",""+US_Open+"" , 9, "Arial", Silver);
   
   
   ObjectDelete("TT7");
   TT7( "TT7", 505, 12,4);
   ObjectSetText( "TT7","EUROPE Close" , 9, "Arial", EUROPE1_TEXT_Color );
    
   ObjectDelete("TT8");
   TT8( "TT8", 505, 12,4);
   ObjectSetText( "TT8",""+EUROPE1_Close+"" , 9, "Arial", Silver);
   
   
  } 
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime decDateTradeDay (datetime dt) {
  int ty=TimeYear(dt);
  int tm=TimeMonth(dt);
  int td=TimeDay(dt);
  int th=TimeHour(dt);
  int ti=TimeMinute(dt);

  td--;
  if (td==0) {
    tm--;
    if (tm==0) {
      ty--;
      tm=12;
    }
    if (tm==1 || tm==3 || tm==5 || tm==7 || tm==8 || tm==10 || tm==12) td=31;
    if (tm==2) if (MathMod(ty, 4)==0) td=29; else td=28;
    if (tm==4 || tm==6 || tm==9 || tm==11) td=30;
  }
  return(StrToTime(ty+"."+tm+"."+td+" "+th+":"+ti));
}
//+------------------------------------------------------------------+
int TT1( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT2( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 120);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT3( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT4( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 120);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT5( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT6( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 120);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT7( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 20);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}
int TT8( string Text, int xOffset, int yOffset,int iCorner) //TITLE
{  ObjectCreate(Text,OBJ_LABEL         , 0, 0, 0 );
   ObjectSet   (Text,OBJPROP_CORNER    , iCorner);
   ObjectSet   (Text,OBJPROP_XDISTANCE , 120);
   ObjectSet   (Text,OBJPROP_YDISTANCE , xOffset );
   ObjectSet   (Text,OBJPROP_BACK      , True );
}

////////////////////////////////////////////////////////////////////////////////////
//                                                 Neumex
//              IBFX(Standard) +-----------------+ Alpari(Standard)
//              GMT_Diff = -1; |                 | GMT_Diff = 1;
//                             |       GMT       |
// ---------+---------+--------+--------+--------+--------+----------------+-----------
//         -3        -2       -1        0        1        2 Neumex         3
//                                      |IBFX(Summer)     | Alpari(Summer) |FXDD(Summer)
//                                      |GMT_Diff = 0;    | GMT_Diff = 2;  |GMT_Diff = 3;
//                                      +-----------------+                |
//                                                        |                |
//                                                        +----------------+
//                                                    FXDD(Standard)
//                                                    GMT_Diff = 2;
////////////////////////////////////////////////////////////////////////////////////
//EUROPE
//Central European Time (CET)
//Standard Time = GMT+1
//Summer Time = GMT+2 
//Summer Time Rule 
//Start: Last Sunday in March
//End: Last Sunday in October
//Time: 1.00 am (01:00) Greenwich Mean Time (GMT) 
//----------------------------------------------------
//Year   DST Begins 1 am GMT  DST Ends 1 am GMT
//----------------------------------------------------
//1999   March 28             October 31
//2000   March 26             October 29
//2001   March 25             October 28
//2002   March 31             October 27 
//2003   March 30             October 26
//2004   March 28             October 31
//2005   March 27             October 30
//2006   March 26             October 29
//2007 	March 25 	         October 28
//2008 	March 30 	         October 26
//2009 	March 29 	         October 25
//2010 	March 28 	         October 31
//2011 	March 27 	         October 30
//UK
//UK Standard Time = GMT
//UK Summer Time = BST (British Summer time) = GMT+1
//For 2003-2007 inclusive, the summer-time periods begin and end respectively on 
//the following dates at 1.00am Greenwich Mean Time:
//2003: the Sundays of 30 March and 26 October
//2004: the Sundays of 28 March and 31 October
//2005: the Sundays of 27 March and 30 October
//2006: the Sundays of 26 March and 29 October
//2007: the Sundays of 25 March and 28 October
//US
//-----------------------------------------------------------------
//Eastern Standard Time (EST) = GMT-5
//Eastern Daylight Time (EDT) = GMT-4
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//     |  (First Sunday in April) |	(Last Sunday in October)
//-----+--------------------------+----------------------------------                                  
//1990 	April 1 	                  October 28
//1991 	April 7 	                  October 27
//1992 	April 5 	                  October 25
//1993 	April 4 	                  October 31
//1994 	April 3 	                  October 30
//1995 	April 2 	                  October 29
//1996 	April 7 	                  October 27
//1997 	April 6 	                  October 26
//1998 	April 5 	                  October 25
//1999 	April 4 	                  October 31
//2000 	April 2 	                  October 29
//2001 	April 1 	                  October 28
//2002 	April 7 	                  October 27
//2003 	April 6 	                  October 26
//2004 	April 4 	                  October 31
//2005 	April 3 	                  October 30
//2006 	April 2 	                  October 29
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//     |  (Second Sunday in March)|	(First Sunday in November)
//-----+--------------------------+----------------------------------                                  
//2007 	March 11 	               November 4
//2008 	March 9 	                  November 2
//2009 	March 8 	                  November 1
//2010 	March 14 	               November 7
//2011 	March 13 	               November 6
//2012 	March 11 	               November 4
//2013 	March 10 	               November 3
//2014 	March 9 	                  November 2
//2015 	March 8 	                  November 1
//-------------------------------------------------------------------
//RO
//Eastern European Time (EET)
//Standard Time = GMT+2
//Summer Time = GMT+3 
//---------------------------------------------------
//Summer Time Rule 
//Start: Last Sunday in March
//End: Last Sunday in October
//Time: 1.00 am (01:00) Greenwich Mean Time (GMT) 
//----------------------------------------------------
//Year   DST Begins 1 am GMT  DST Ends 1 am GMT
//----------------------------------------------------
//1999   March 28             October 31
//2000   March 26             October 29
//2001   March 25             October 28
//2002   March 31             October 27 
//2003   March 30             October 26
//2004   March 28             October 31
//2005   March 27             October 30
//2006   March 26             October 29
//2007 	March 25 	         October 28
//2008 	March 30 	         October 26
//2009 	March 29 	         October 25
//2010 	March 28 	         October 31
//2011 	March 27 	         October 30  


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GMT_TO_REGION(string region,string datetime_gmt) 
{
  string r1;
  int diff=GMT_Offset(region,StrToTime(datetime_gmt));
  int hr=TimeHour(StrToTime(datetime_gmt));
  int res = hr+diff;
  if (res < 0) res = 24 + res;
  if (res > 23) res = res - 24;
  r1= DoubleToStr(TimeYear(StrToTime(datetime_gmt)),0)+"."+
      DoubleToStr(TimeMonth(StrToTime(datetime_gmt)),0)+"."+
      DoubleToStr(TimeDay(StrToTime(datetime_gmt)),0)+" "+
      DoubleToStr(res,0)+":"+
      DoubleToStr(TimeMinute(StrToTime(datetime_gmt)),0);
  return (r1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string REGION_TO_GMT(string region,string datetime_region) 
{
  string r1;
  int diff=GMT_Offset(region,StrToTime(datetime_region));
  int hr=TimeHour(StrToTime(datetime_region));
  int res = hr - diff;
  if (res < 0) res = 24 + res;
  if (res > 23) res = res - 24;
  r1= DoubleToStr(TimeYear(StrToTime(datetime_region)),0)+"."+
      DoubleToStr(TimeMonth(StrToTime(datetime_region)),0)+"."+
      DoubleToStr(TimeDay(StrToTime(datetime_region)),0)+" "+
      DoubleToStr(res,0)+":"+
      DoubleToStr(TimeMinute(StrToTime(datetime_region)),0);
  return (r1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT_Offset(string region,datetime dt1)
{
  int r1=0;
  if (region== "EUROPE")
    r1=GMT1(dt1);
  else if (region=="LONDON")    
    r1=GMT0(dt1);
  else if (region=="US")        
    r1=GMT_5(dt1); 
  else if (region=="Alpari Ltd.")    
    r1=GMT1(dt1); 
  else if (region=="Gimex Group")  //NEUMEX  
    r1=GMT1(dt1); 
  else if (region=="FXDirectDealer")   //FXDD   
    r1=GMT2(dt1); 
  else if (region=="Interbank FX, LLC.")      
    r1=GMT_1(dt1); 
  else if (region=="FIBO Group Ltd.")      
    r1=GMT0(dt1); 
  else if (region=="Velocity4x") 
    r1=GMT0(dt1); 
  else if (region=="RO")        
    r1=GMT2(dt1); 
  
    return (r1);

}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool is_leap_year(int year1)
{
 
  if ((MathMod(year1,100)==0) && (MathMod(year1,400)==0))
    return(true);
  else if ((MathMod(year1,100)!=0) && (MathMod(year1,4)==0))  
    return(true);
  else 
    return (false); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int n_days(int year1,int month1)
{
  int ndays1;
  if (month1==1)
    ndays1=31;
  else if(month1==2)
  {
    if (is_leap_year(year1))
      ndays1=29;      
    else
      ndays1=28;  
  }    
  else if(month1==3)
    ndays1=31;  
  else if(month1==4)
    ndays1=30;  
  else if(month1==5)//mai
    ndays1=31;  
  else if(month1==6)//iun          
    ndays1=30;  
  else if(month1==7)//iul          
    ndays1=31;  
  else if(month1==8)//aug          
    ndays1=31;  
  else if(month1==9)//sep          
    ndays1=30;  
  else if(month1==10)//oct          
    ndays1=31;  
  else if(month1==11)//nov          
    ndays1=30;  
  else if(month1==12)          
    ndays1=31;  
  
  return(ndays1);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int n_sdays(int year1,int month1)
{
  datetime ddt2;
  int ndays2=n_days(year1,month1);
  int i,nsun1=0;  
  for (i=1;i<=ndays2;i++) 
  {
    ddt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");            
    if(TimeDayOfWeek(ddt2)==0)
      nsun1=nsun1+1; 
  }   
  return(nsun1);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime last_sunday(int year1,int month1)
{
  int i,ndays2,nsun1,nsun2;
  datetime dt2,dt3;
  ndays2=n_days(year1,month1);
  nsun2=n_sdays(year1,month1);
  nsun1=0;
  for (i=1;i<=ndays2;i++) 
  {
    dt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");                    
    if(TimeDayOfWeek(dt2)==0)
    {       
      nsun1=nsun1+1; 
    }  
    if (nsun1==nsun2) 
    {
      dt3=dt2;  
      break;        
    }  
  }   
  return(dt3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime first_sunday(int year1,int month1)
{
  int i,ndays2,nsun1,nsun2;
  datetime dt2,dt3;
  ndays2=n_days(year1,month1);
  nsun2=1;//n_sdays(year1,month1);
  nsun1=0;
  for (i=1;i<=ndays2;i++) 
  {
    dt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");                    
    if(TimeDayOfWeek(dt2)==0)
    {       
      nsun1=nsun1+1; 
    }  
    if (nsun1==nsun2) 
    {
      dt3=dt2;  
      break;        
    }  
  }   
  return(dt3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime second_sunday(int year1,int month1)
{
  int i,ndays2,nsun1,nsun2;
  datetime dt2,dt3;
  ndays2=n_days(year1,month1);
  nsun2=2;//n_sdays(year1,month1);
  nsun1=0;
  for (i=1;i<=ndays2;i++) 
  {
    dt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");                    
    if(TimeDayOfWeek(dt2)==0)
    {       
      nsun1=nsun1+1; 
    }  
    if (nsun1==nsun2) 
    {
      dt3=dt2;  
      break;        
    }  
  }   
  return(dt3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT1(datetime dt1)
{
//EUROPE
//Summer Time Rule 
//Start: Last Sunday in March
//End: Last Sunday in October
//Time: 1.00 am (01:00) Greenwich Mean Time (GMT) 
  
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(2);
  else
   return(1); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT2(datetime dt1)
{
//EUROPE
//Summer Time Rule 
//Start: Last Sunday in March
//End: Last Sunday in October
//Time: 1.00 am (01:00) Greenwich Mean Time (GMT) 
  
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(3);
  else
   return(2); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT_1(datetime dt1)
{
//EUROPE
//Summer Time Rule 
//Start: Last Sunday in March
//End: Last Sunday in October
//Time: 1.00 am (01:00) Greenwich Mean Time (GMT) 
  
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(0);
  else
   return(-1); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT_5(datetime dt1)
{
//US
//-----------------------------------------------------------------
//Eastern Standard Time (EST) = GMT-5
//Eastern Daylight Time (EDT) = GMT-4
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//1990-|                          |
//2006 |  (First Sunday in April) |	(Last Sunday in October)
//-----+--------------------------+----------------------------------                                  
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//2007-|  (Second Sunday in March)|	(First Sunday in November)
//-----+--------------------------+----------------------------------                                  

 if(TimeYear(dt1)<2007)
   if ((dt1>first_sunday(TimeYear(dt1),4))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(-4);
    else
     return(-5); 
 else
   if ((dt1>second_sunday(TimeYear(dt1),3))&&(dt1<first_sunday(TimeYear(dt1),11)))
     return(-4);
    else
     return(-5); 
     
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GMT0(datetime dt1)
{
//UK Standard Time = GMT
//UK Summer Time = BST (British Summer time) = GMT+1
//For 2003-2007 inclusive, the summer-time periods begin and end respectively on 
//the following dates at 1.00am Greenwich Mean Time:
//2003: the Sundays of 30 March and 26 October
//2004: the Sundays of 28 March and 31 October
//2005: the Sundays of 27 March and 30 October
//2006: the Sundays of 26 March and 29 October
//2007: the Sundays of 25 March and 28 October
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(1);//summer
  else
   return(0); 

}